/**
 *  Arduino Code Drawing Robot Bluetooth [HC-05] 
 *
 *  Antonios Chatzisavvas [st0933@icte.uowm.gr] & Panagiotis Pourgias [st0949@icte.uowm.gr] 
 *  UOWM ICTE [http://icte.uowm.gr/] & [http://arch.icte.uowm.gr/]
 *  August 2017
 *  
 *
 */


#include <Stepper.h>
#include <Servo.h>

String readcom; //read command from application

#define STEPS_PER_MOTOR_REVOLUTION 32
#define STEPS_PER_OUTPUT_REVOLUTION 32 * 64  //2048  
Stepper small_stepper(STEPS_PER_MOTOR_REVOLUTION, 9, 11, 12, 10);
Stepper small_stepper1(STEPS_PER_MOTOR_REVOLUTION, 4, 6, 7, 5);
int servoPin = 8;
int PEN_DOWN = 80; // angle of servo when pen is down
int PEN_UP = 140;   // angle of servo when pen is up
Servo penServo;
String com = "";
boolean serComplete = false;
bool pen_pos = true;


int stepp = 800;    // ta bimata poy 8a kanei me thn ka8e entolh apo to app
int deg = 400;     // tis mires poy 8a kanei me thn ka8e entolh apo to app (pali bash bhmaton)


void setup()
{
  Serial.begin(9600);
  com.reserve(200);

  penServo.attach(servoPin);
}


void loop()
{

  small_stepper.setSpeed(700);
  small_stepper1.setSpeed(700);

  while (Serial.available()) { 
    delay(10);
    char c = Serial.read();
    readcom += c; 
  }
  
  if (readcom.length() > 0) {
    Serial.println(readcom);
    
    if (readcom == "forward"){
        forward();
        delay(100);
    }
    else if (readcom == "backward"){
      backward();
      delay(100);
    }
    else if (readcom == "left"){
      left();
      delay(100);
    }
    else if (readcom == "right"){
      right();
      delay(100);
    }
    else if (readcom == "pen"){
      pen();
      delay(100);
    }
    
  readcom = "";
  
  }
}



void forward() {

  Serial.println("forward()");
  for (int i = 0; i < stepp; i++) {
    small_stepper.step(1);
    small_stepper1.step(1);
  }
}
void backward() {

  Serial.println("backward()");
  for (int i = 0; i < stepp; i++) {
    small_stepper.step(-1);
    small_stepper1.step(-1);
  }
}
void left() {

  Serial.println("left()");
  small_stepper.step(deg);
  small_stepper1.step(-deg);

}
void right() {

  Serial.println("right()");
  small_stepper1.step(deg);
  small_stepper.step(-deg);

}
void pen() {

  if (pen_pos) {
    delay(250);
    Serial.println("PEN_DOWN()");
    penServo.write(PEN_DOWN);
    delay(250);
    pen_pos = false;
  }
  else if (pen_pos == false) {
    delay(250);
    Serial.println("PEN_UP()");
    penServo.write(PEN_UP);
    delay(250);
    pen_pos = true;
  }
}

void serialEvent() {
  while (Serial.available()) {
    com = (char)Serial.read();   // new Byte ..
    //com += inChar;
    //if (inChar == '\n') {
    serComplete = true;
  }
}



